<template>
  <st-content heading="Tutoría al momento">
    <div>
      <div class="content-body">
          <st-subtitle text="Registra o programa una sesion de tutoría al momento"/>
        <v-row justify="center">
            <template>
              <div class="rolLogin">
                <st-primary-btn class="mb-5"
                  @click = "dialog = true"
                  nombre="Registrar sesión de tutoría al momento"
                />
                <v-img src="../../images/planta.png" height="200" contain></v-img>
              </div>
            </template>

        </v-row>
      </div>
    </div>
    <v-row justify="center">
    <v-dialog v-model="dialog" persistent max-width="800">
      <v-card>

        <v-card-title class="headline"><st-title text="Registro de sesión de tutoría al momento"/></v-card-title>

        <v-card-text>
      <st-subtitle text="Seleccionar alumno" class="sinfo"/>
      <st-search
        md="12"
        text="Buscar por nombre o código"
        @enter="getItems($event)"
      />
      <st-select-table
        :dataInfo="{ headers, items, key }"
        :loading="loading"
        @selected="enable($event)"
      />

  </v-card-text>

        <v-card-actions >
            <v-row no-gutters justify="end">
        <v-spacer></v-spacer>
          <st-secondary-btn nombre="Cancelar" @click="dialog = false"/>
          <st-primary-btn
            nombre = "Registrar sesion"
            :loading = "loadingBtn"
            @click = "validate"
            :disable = !valid
        />
            </v-row>
        </v-card-actions>

      </v-card>
    </v-dialog>
  </v-row>
  </st-content>
</template>

<script>
import Search from '@/components/Search'
import SelectTable from '@/components/SelectTable'
export default {
  data () {
    return {
      dialog :false,
      loading: false,
      loadingBtn: false,
      idTutor : '80dd6af9-20f9-4099-98cb-fa2b1d167645',
      student:{},
      valid:false,
      headers: [
        {
          text: 'Nombre',
          align: 'start',
          value: 'nombre',
        },
        {
          text: 'Código',
          value: 'codigo'
        },
        {
          text: 'Unidad',
          value: 'nombreUnidad'
        },
      ],
      items: [],
      key: 'idAlumno',
      hora : new Date().toISOString(),
    }
  },
  components: {
    'st-search': Search,
    'st-select-table': SelectTable
  },
  methods: {
    async getItems(search){
        this.loading = true
        let { data: { data } } = await this.$api.getMomentSessionStudents(this.$store.state.role.id,search)
        let items = data.map(({idUnidad, nombreUnidad,alumno}) => ({idUnidad, nombreUnidad, ...alumno}))
        this.loading = false
        this.items = items
    },
    convert(dia){
      let fecha = dia.toISOString()
      let hh = parseInt(fecha.substr(11,2))
      if(hh < 5) dia.setDate(dia.getDate() - 1);
      hh = (hh - 5 + 24)%24
      let aux = dia.toISOString().substr(0,11) + hh.toString(10) + dia.toISOString().substr(13,11)
      this.hora = aux
    },
    async validate() {
      this.loadingBtn = true
      var d = new Date();
      this.convert(d)
      let data = {

          'sesion': {
            'idTutor': this.$store.state.role.id,
            'idAlumno': this.student.idAlumno,
            'fechaInicial': new Date().toISOString(),  //;//this.hora,//this.hora, //ISO8601, fecha y hora
            'idUnidad': this.student.idUnidad,
          }

      }
      try{
        this.loadingBtn = true
        let response = await this.$api.addMomentSession(data)
        let id  = response.data.data.idSesion
        let path = '/tutor/tutorias/' + id
        //this.$emit('refresh',{ response: response})
        this.$router.push(path)
      } catch(e) {
        this.$store.commit('setError', e)
      }
      this.loadingBtn = false
    },
    enable(row){
      this.student = row
      this.valid = (this.student != null);
    },
  },

}
</script>

<style scoped lang="scss">
/* scope for encapsulate css */
.rolLogin {
  height: 700px;
  width: 175px;
  margin: 10px;
  border-radius: 10px;
  display: flex;
  flex-wrap: wrap;
  align-content: center;
  justify-content: center;
}
.sinfo{
  margin:20px 0 0 10px;
}
</style>
